/*	--*- c -*--
 * Copyright (C) 2009 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef H_ENSC_DHCPD_SIMPLE_DHCPD_H
#define H_ENSC_DHCPD_SIMPLE_DHCPD_H

#include <stdlib.h>
#include <stdbool.h>
#include "list.h"

struct dhcpd_param {
	bool			(*filter)(struct dhcpd_param const *param);
	ssize_t			(*fill)(struct dhcpd_param const *param,
					void *buf, size_t buf_len);

	unsigned char		code;

	struct list_head	head;

	size_t			info_len;
	unsigned char		info[];
};

struct dhcpd_param *	dhcpd_param_parse(char const *str);

#endif	/* H_ENSC_DHCPD_SIMPLE_DHCPD_H */
