/*	--*- c -*--
 * Copyright (C) 2009 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef H_ENSC_DHCPD_SIMPLE_MISC_H
#define H_ENSC_DHCPD_SIMPLE_MISC_H

#define container_of(OBJ,STRUCT,MEMBER)  __extension__			\
	({ __typeof__(STRUCT::MEMBER)	*_tmp =				\
			((void *)(OBJ)) - offsetof(STRUCT, MEMBER);	\
		_tmp; })

#define BUILD_BUG_ON_ZERO(e) (sizeof(char[1 - 2 * !!(e)]) - 1)

#define ARRAY_SIZE(A)\
	(sizeof(A)/sizeof((A)[0]) + _must_be_array(A))
	

#define _must_be_array(a)						\
	BUILD_BUG_ON_ZERO(__builtin_types_compatible_p(typeof(a), typeof(&a[0])))

#endif	/* H_ENSC_DHCPD_SIMPLE_MISC_H */
